# The parameters required for lines are:
# 1. The initial point (x, y)
# 2. The end point (x2, y2)
# 3. The rgba values for the color and transparency (r, g, b, a)

# An example of creating a line would be:
# args.outputs.lines << [100, 100, 300, 300, 255, 0, 255, 255]

# This would create a line from (100, 100) to (300, 300)
# The RGB code (255, 0, 255) would determine its color, a purple
# It would have an Alpha value of 255, making it completely opaque

def tick args
  args.outputs.labels << [480, 620, "Lines (x, y, x2, y2, r, g, b, a)"]

  # Some simple lines
  args.outputs.lines  << [380, 450, 675, 450]
  args.outputs.lines  << [380, 410, 875, 410]

  # These examples utilize args.game.tick_count to change the length of the lines over time
  # args.game.tick_count is the ticks that have occurred in the game
  # This is accomplished by making either the starting or ending point based on the args.game.tick_count
  args.outputs.lines  << [380, 370, 875, 370, args.game.tick_count % 255, 0, 0, 255]
  args.outputs.lines  << [380, 330 - args.game.tick_count % 25, 875, 330, 0, 0, 0, 255]
  args.outputs.lines  << [380 + args.game.tick_count % 400, 290, 875, 290, 0, 0, 0, 255]
end
