class ControllerDemo
  attr_accessor :inputs, :game, :outputs

  def tick
    process_inputs
    render
  end

  def process_inputs
    game.buttons = []

    game.buttons << [100, 500, inputs.controller_one.key_held.l1, "L1"]
    game.buttons << [100, 600, inputs.controller_one.key_held.l2, "L2"]

    game.buttons << [1100, 500, inputs.controller_one.key_held.r1, "R1"]
    game.buttons << [1100, 600, inputs.controller_one.key_held.r2, "R2"]

    game.buttons << [540, 450, inputs.controller_one.key_held.select, "Select"]
    game.buttons << [660, 450, inputs.controller_one.key_held.start, "Start"]

    game.buttons << [200, 300, inputs.controller_one.key_held.left, "Left"]
    game.buttons << [300, 400, inputs.controller_one.key_held.up, "Up"]
    game.buttons << [400, 300, inputs.controller_one.key_held.right, "Right"]
    game.buttons << [300, 200, inputs.controller_one.key_held.down, "Down"]

    game.buttons << [800, 300, inputs.controller_one.key_held.x, "X"]
    game.buttons << [900, 400, inputs.controller_one.key_held.y, "Y"]
    game.buttons << [1000, 300, inputs.controller_one.key_held.a, "A"]
    game.buttons << [900, 200, inputs.controller_one.key_held.b, "B"]

    game.buttons << [450 + inputs.controller_one.left_analog_x_perc * 100,
                     100 + inputs.controller_one.left_analog_y_perc * 100,
                     inputs.controller_one.key_held.l3,
                    "L3"]

    game.buttons << [750 + inputs.controller_one.right_analog_x_perc * 100,
                     100 + inputs.controller_one.right_analog_y_perc * 100,
                     inputs.controller_one.key_held.r3,
                    "R3"]
  end

  def render
    game.buttons.each do |x, y, active, text|
      rect = [x, y, 75, 75]

      if active
        outputs.solids << rect
      else
        outputs.borders << rect
      end

      outputs.labels << [x, y + 95, text]
    end
  end
end

$controller_demo = ControllerDemo.new

def tick args
  $controller_demo.inputs = args.inputs
  $controller_demo.game = args.game
  $controller_demo.outputs = args.outputs
  $controller_demo.tick
end

def r
  $dragon.reset
end
