# To determine whether a point is in a rect
# Use point.inside_rect? rect

# This is useful to determine if a click occurred in a rect

def tick args
  x = 460

  args.outputs.labels << small_label(args, x, 15, "Click inside the blue box maybe ---->")

  box = [785, 370, 50, 50, 0, 0, 170]
  args.outputs.borders << box

  # Saves the most recent click into args.game
  # Unlike the other components of args,
  # args.game does not reset every tick.
  if args.inputs.mouse.click
    args.game.last_mouse_click = args.inputs.mouse.click
  end

  if args.game.last_mouse_click
    if args.game.last_mouse_click.point.inside_rect? box
      args.outputs.labels << small_label(args, x, 16, "Mouse click happened *inside* the box.")
    else
      args.outputs.labels << small_label(args, x, 16, "Mouse click happened *outside* the box.")
    end
  else
    args.outputs.labels << small_label(args, x, 16, "Mouse click has not occurred yet.")
  end
end

def small_label args, x, row, message
  [x, row_to_px(args, row), message, small_font]
end

def small_font
  [-2, 0, 0, 0, 0, 255]
end

def row_to_px args, row_number
  args.grid.top.shift_down(5).shift_down(20 * row_number)
end
