GAME_FILE = 'app/decision.rb'

require GAME_FILE

def tick args
  if !args.state.loaded && !respond_to?(:game)
    args.labels << [640, 370, 'Hey there! Welcome to Four Decisions.', 0, 1]
    args.labels << [640, 340, 'Go to the file called decision.rb and tell me your story.', 0, 1]
  elsif respond_to?(:game)
    args.state.loaded = true
    tick_game args
  end

  if args.state.tick_count.mod_zero? 60
    t = args.gtk.ffi_file.mtime GAME_FILE
    if t != args.state.mtime
      args.state.mtime = t
      require GAME_FILE
      args.state.game_definition = nil
      args.state.decision_id = nil
    end
  end
end

def tick_game args
  defaults args
  args.borders << args.grid.rect
  render_decision args
  process_inputs args
end

def defaults args
  args.state.game_definition ||= game
  args.state.decision_id ||= args.state.game_definition[:starting_decision]
end

def render_decision args
  decision = current_decision args
  args.labels << [640, 360, decision[:description] || "No definition found for #{args.state.decision_id}. Please update decision.rb.", 0, 1]

  if decision[:option_one]
    args.labels << [10, 360, decision[:option_one][:description], 0, 0]
    args.labels << [10, 335, "(Press 'left' on the keyboard to select this decision)", -5, 0]
  end

  if decision[:option_two]
    args.labels << [1270, 360, decision[:option_two][:description], 0, 2]
    args.labels << [1270, 335, "(Press 'right' on the keyboard to select this decision)", -5, 2]
  end

  if decision[:option_three]
    args.labels << [640, 45, decision[:option_three][:description], 0, 1]
    args.labels << [640, 20, "(Press 'down' on the keyboard to select this decision)", -5, 1]
  end

  if decision[:option_four]
    args.labels << [640, 700, decision[:option_four][:description], 0, 1]
    args.labels << [640, 675, "(Press 'up' on the keyboard to select this decision)", -5, 1]
  end
end

def process_inputs args
  decision = current_decision args

  if args.keyboard.key_down.left! && decision[:option_one]
    args.state.decision_id = decision[:option_one][:decision]
  end

  if args.keyboard.key_down.right! && decision[:option_two]
    args.state.decision_id = decision[:option_two][:decision]
  end

  if args.keyboard.key_down.down! && decision[:option_three]
    args.state.decision_id = decision[:option_three][:decision]
  end

  if args.keyboard.key_down.up! && decision[:option_four]
    args.state.decision_id = decision[:option_four][:decision]
  end
end

def current_decision args
  args.state.game_definition[:decisions][args.state.decision_id] || {}
end

$gtk.reset
